#include "FC2720.h"

enum status
{
  POWER_ON,SLEEPING,CHRGING,DISCHRGING,
  HEAT_LEVEL_1,HEAT_LEVEL_2
};

#define   ADC_NUM_58   201 
#define   ADC_NUM_60   141 
#define   ADC_NUM_68   152 
#define   ADC_NUM_70   154

//#define   ADC_NUM_58   201 
//#define   ADC_NUM_60   204 
//#define   ADC_NUM_68   215 
//#define   ADC_NUM_70   217


#define   P_LED_R      FP11
#define   P_LED_G      FP12
#define   P_LED_B      FP14
#define   P_KEY1       FP16      
#define   P_STDBY      FP31      
#define   P_CHRG       FP30  

#define   P_OUT        FP15  
#define   HEAT_ENABLE  P_OUT=1
#define   HEAT_DISABLE P_OUT=0

#define   P_AD         FP34 
#define   AD_ENABLE    P_AD=1
#define   AD_DISABLE   P_AD=0

#define   R_ON         P_LED_R=0
#define   R_OFF        P_LED_R=1
#define   G_ON         P_LED_G=0
#define   G_OFF        P_LED_G=1
#define   B_ON         P_LED_B=0
#define   B_OFF        P_LED_B=1
    

bit       bit1ms=0;
bit       bit5ms=0;
bit       bit8ms=0;
bit       bit10ms=0;
bit       bitChrg=0;              
bit       bitStdby=0;      
bit       bitShortClick=0;      
bit       bitLongClick=0;  
bit       bitKeyLock=0;
bit       bitToggle=0;
bit       bitLowVoltage=1;




uint8_t ADC_Now=0,ADC_Last=0,ADC_VALUE=0;
uint8_t u8SamplingCnt=0;
uint8_t u8Duty=0;
enum status u8Status=POWER_ON;
void delay_1ms(uint8_t x_1ms);
/*Function statment<<=========================================================*/
void SysInit(void);
void scan_key(void);
void Get_ADC(void);
void t0_enable(void);
void get_energy_level(void);
void show_battery_energy_by_4led(uint8_t tmp);
void pwm_disable(void);
void pwm10_enable(void);
void pwm12_enable(void);
/******************************************************************************************************
*      ƣжϷ
*      ܣֻ
*  ڲ
*  ڲ
*      ڣ2019.6.14
*      ߣм
******************************************************************************************************/
void __interrupt[0x8] isr(void)
{	
  static uint8_t j=0,z=0,y=0;
  if(FT0IF)
  {
	FT0IF=0;    
    T0C=68;      //װֵ	  
    bit1ms=1;
    j++;
    z++;
    y++;
    if(j>4)
	{
	  j=0;
      bit5ms=1;
	} 
	if(y>7)
	{
	  y=0;
	  bit8ms=1;
	}
    if(z>9)
	{
	  z=0;
      bit10ms=1;
	}	
  }	
//  INTRQ=0;
//  INTRQ1=0;			
}
/******************************************************************************************************
*      ƣ
*      ܣ
*  ڲ   
*  ڲ
*      ڣ2018.4.13
*      ߣ
******************************************************************************************************/
void main(void)
{
    uint8_t x=0;
    SysInit();
    AD_ENABLE;
    ADPCON=0x20;    
    VREFH=0x03;   //ڲοѹ:  VDD:0x03   4.0V:0x02   3.0V:0x01    2.0V:0x00
    ADM  =0x95;   //P35 ΪAD
	t0_enable();
	bit1ms=0;
    x=0;
    while(1)
    {
		WDTR=0X5A;//幷
		
		switch(u8Status)
		{
		  case POWER_ON:
		  //ϵ200msADCͰ	  
	      if(bit1ms)
		  { 
			bit1ms=0;
			x++; 			
			scan_key();		
		    Get_ADC();			
		  }
          if(x>200)
          {
		    x=0;			
			if((bitChrg==1)&&(bitStdby==0))
			{			  	
			  u8Status=DISCHRGING;  //ŵ 
			  pwm10_enable();
			  break;
			}
			
            if((bitChrg==0)&&(bitStdby==1))
			{			  	
			  u8Status=CHRGING;     // 
			  pwm12_enable();
			  break;
			}       				
            u8Status=SLEEPING;	 
          }			  
		  break;			
			
		  case HEAT_LEVEL_1://һ
		  if(bit1ms)
		  {
			bit1ms=0;
			Get_ADC();
			if(ADC_VALUE>ADC_NUM_60)
			{
			  HEAT_DISABLE;
			}
			if(ADC_VALUE<ADC_NUM_58)
			{
			  HEAT_ENABLE;			
			}
		    scan_key();
			G_ON;//̵
			if(bitShortClick)
			{
			  G_OFF;
              bitShortClick=0;
              u8Status=HEAT_LEVEL_2;	  
			} 			
			if(bitLongClick)
			{	
              bitLongClick=0;
              u8Status=SLEEPING;	  
			}  
		    if(bitStdby==0)
		    {
			  G_OFF;
			  HEAT_DISABLE;		    
			  u8Status=DISCHRGING; 
			  pwm10_enable();
		    }			
            if(bitChrg==0)
			{
			  G_OFF;
			  HEAT_DISABLE;			
			  u8Status=CHRGING;
			  pwm12_enable();
            }						
          }			
		  break;
		  
		  case HEAT_LEVEL_2://ȶ
		  if(bit1ms)
		  {
			bit1ms=0;
			Get_ADC();
			if(ADC_VALUE>ADC_NUM_70)
			{
			  HEAT_DISABLE;
			}
			if(ADC_VALUE<ADC_NUM_68)
			{
			  HEAT_ENABLE;			
			}
		    scan_key();
			R_ON;//
			if(bitShortClick)
			{
			  R_OFF;
              bitShortClick=0;
              u8Status=HEAT_LEVEL_1;	  
			} 			
			if(bitLongClick)
			{
              bitLongClick=0;
              u8Status=SLEEPING;	  
			}  
		    if(bitStdby==0)
		    {
		      R_OFF;
			  u8Status=DISCHRGING; 
			  pwm10_enable();
			  HEAT_DISABLE;
		    }			
            if(bitChrg==0)
			{
		      R_OFF;			
			  u8Status=CHRGING; 
			  pwm12_enable();
			  HEAT_DISABLE;
            }						
          }			
		  break;
		  
		  case CHRGING://
		  if(bit1ms)
		  {	  
		    bit1ms=0;
            scan_key();	
            if(bitLongClick)
            bitLongClick=0;
            
            if(bitShortClick)
            bitShortClick=0;
            
            //ʱƺ
			if(bitChrg==0)
			{
			   if(bit8ms)
			   {
			     bit8ms=0;
			     if(bitToggle)
			     {
			       u8Duty++;
			       if(u8Duty==255)
			       {
			         bitToggle=0;
			       }  
			     }
			     else
			     {
			       u8Duty--;
			       if(u8Duty==0)
			       {
			         bitToggle=1;
			       }  
			     }
			     TM1D2=u8Duty;
			  }   
			}
			else 
			{
			  G_ON;//?
			  if(bitStdby==0)
			  {
			    u8Status=POWER_ON;
			  }
			}
          }			
		  break;

		  case DISCHRGING://ŵ
		  if(bit1ms)
		  {	  
		    bit1ms=0;
            scan_key();

            if(bitLongClick)
            bitLongClick=0;
            
            if(bitShortClick)
            bitShortClick=0;

            //ŵʱ,ƺ
		    if(bitStdby==0)	
		    {
		       if(bit8ms)
		       {
		         bit8ms=0;
			     if(bitToggle)
			     {
			       u8Duty++;
			       if(u8Duty==255)
			       {
			         bitToggle=0;
			       }  
			     }
			     else
			     {
			       u8Duty--;
			       if(u8Duty==0)
			       {
			         bitToggle=1;
			       }  
			     } 
			     TM1D0=u8Duty;
			   }
			   
		    }
		    else
		    {
			  u8Status=POWER_ON;
		    }
          }			
		  break;		  
		  
		  case SLEEPING://˯
		  SysInit();
		  //ȴͷ
          for(x=0;x<30;x++)         
          {
            if(P_KEY1==0)x=0;
            delay_1ms(1);
          } 
		  FRPIE=1;          //˿ж?
		  do
		  {
			SLEEPMODE; 
		  }while((P_STDBY)&&(P_CHRG)&&(P_KEY1)); 
		  FRPIE=0;          //رն˿ж
		  if(P_CHRG=0)
		  {
	        u8Status=POWER_ON;
	        t0_enable();	        
	      }
	      if(P_STDBY=0)
	      {
	        u8Status=POWER_ON;
	        t0_enable();	        
	      }

	      if(P_KEY1==0)
	      {
	        x=0;
	        while(1)
	        {
	          x++;
              if(P_KEY1==0)x=0;
              if(x>2)break;
            
	          delay_1ms(10);
	          bit10ms=1;
       	      scan_key();  
       	      if(bitLongClick)
	          {
	            bitLongClick=0;
	            AD_ENABLE;
                ADPCON=0x20;    
                VREFH=0x03;   //ڲοѹ:  VDD:0x03   4.0V:0x02   3.0V:0x01    2.0V:0x00
                ADM  =0x95;   //P35 ΪAD
	            u8Status=HEAT_LEVEL_1;
	            t0_enable();
	            break;
	          }
	        }
	      } 
		  break;		  
		}	  
	}
}
/******************************************************************************************************
*      :رPWM
*      ܣ
*  ڲ   
*  ڲ
*      ڣ2019.7.18
*      ߣ
******************************************************************************************************/
void pwm10_enable(void)
{
  FP14=1;
  FP11=1;
  TM1D0=255;   //PWM10ߵƽʱ,TM1D0-TM1C
  TM1C=0;    //ʼֵ
  PWM1E=0x10;//P14PWM10ź
  TM1M=0xD7;
}

void pwm12_enable(void)
{
  FP14=1;
  FP11=1;
  TM1D1=255; //PWM10ߵƽʱ,TM1D0-TM1C
  TM1C=0;    //ʼֵ
  PWM1E=0x42;//P14PWM10ź
  TM1M=0xD6;
}
/*
void pwm11_enable(void)
{
  FP14=1;
  FP11=1;
  TM1D1=255; //PWM10ߵƽʱ,TM1D0-TM1C
  TM1C=0;    //ʼֵ
  PWM1E=0x21;//P14PWM10ź
  TM1M=0xD6;
}*/


void pwm_disable(void)
{
  FP14=1;
  FP11=1;
  PWM1E=0x00;
  TM1M=0x00;  
}	
/******************************************************************************************************
*      ƣvoid scan_key(void)
*      ܣ
*  ڲ
*  ڲ
*  ˵    
*      
*      ڣ2019613
*      ߣм
******************************************************************************************************/
void scan_key(void)
{
  static uint8_t u8Count1=0; 
  static uint8_t u8Count2=0; 
  static uint8_t u8Count3=0;
  static uint8_t u8Count4=0;
  static uint8_t u8Count5=0;  
  static uint8_t u8Count6=0; 
  static uint8_t u8Count7=0;  
  //static uint8_t u8Count8=0;  
  
  static bit bitShortClickTmp=0;   
   
  if(LVDF)
  {
    //1:Դѹ趨ѹ
    u8Count5=0;
    if(++u8Count6>50)
    {
      u8Count6=0;
      bitLowVoltage=1;
    }
  }
  else
  {
    u8Count6=0;
    if(++u8Count5>50)
    {
      u8Count5=0;
      bitLowVoltage=0;
    }    
    //0:ԴѹС趨ѹ   
  }

  
  //
  if(P_STDBY)
  { 
    u8Count2=0;
    if(++u8Count1>100)
    {
      u8Count1=0;
      bitStdby=1; 
    }   
  }        
  else
  {
    u8Count1=0;   
    if(++u8Count2>100)
    {
      u8Count2=0;
      bitStdby=0; 
    }
  }

  //
  if(P_CHRG)
  { 
    u8Count3=0;
    if(++u8Count4>100)
	{
      u8Count4=0;		
      bitChrg=1;
    }	  
  }        
  else
  {
    u8Count4=0;   
    if(++u8Count3>100)
    {
	  u8Count3=0;
      bitChrg=0;  
    }    
  }
   
  

#if 0 
  //ؼ
  if(P_SWITCH)
  { 
    u8Count6=0;
    if(++u8Count5>10)
    {		
      u8Count5=0;
      bitSwitch=1;  
      FP37=0;//
    }   
  }        
  else
  {
    u8Count5=0; 
    if(++u8Count6>50)
	{	
      u8Count6=0;
      bitSwitch=0;     
      FP37=1;//
    } 
  }
#endif  

  //
  if(bit10ms)
  {
    bit10ms=0;
    if(P_KEY1)
    {	
      u8Count7=0;
      //u8Count8++;
      //if(u8Count8>3)
      {
      //  u8Count8=0;
        bitKeyLock=0;
        if(bitShortClickTmp)
        {
          bitShortClickTmp=0;
          bitShortClick=1;
        }        
      }  
    }  	   
    else if(bitKeyLock==0)
    {  
      //u8Count8=0;    
      u8Count7++;
      if(u8Count7>4)
      {
        bitShortClickTmp=1;
      }
      if(u8Count7>200)
      {
        bitShortClickTmp=0;
        bitLongClick=1;		
        bitKeyLock=1;		
	    u8Count7=0;	
      }	  
    }
  }
}
/******************************************************************************************************
*      : Get_ADC 
*      ܣѯADCתģʽ,жģʽ
*  ڲ   
*  ڲ
*      ڣ2018.1.4
*      ߣ
******************************************************************************************************/
void Get_ADC(void)
{
  ADC_Last=ADC_Now;  	
  FADS =1;            //ʼADCת
  while(FADS);     //ȴADCת
  ADC_Now=ADB;

  if(ADC_Last==ADC_Now)
  {
    u8SamplingCnt++;      //ۼ
    if(u8SamplingCnt>8)   //
    {
      u8SamplingCnt=0;		
	  ADC_VALUE=ADC_Now;  	  
    }	  
  }
  else
  {
    u8SamplingCnt=0;  
  }  
} 	
/******************************************************************************************************
*      ƣvoid delay_1ms(uint8_t x_1ms)
*      ܣʱ x_1ms ,ϵͳƵΪ12M/4
*  ڲx_1ms    
*  ڲ
*      ڣ2017.11.14
*      ߣм
******************************************************************************************************/
void delay_1ms(uint8_t x_1ms)
{
  uint8_t i=0;
  WDTR=0x5A;
  for(;x_1ms>0;x_1ms--)
  {
    for(i=249;i>0;i--)
	{
      __asm{nop};
	  __asm{nop};
	  __asm{nop};
	  __asm{nop};
      __asm{nop};
      __asm{nop};
    }
  }
}
/******************************************************************************************************
*      ƣvoid t0_enable(void)
*      ܣt0ʱж
*  ڲ
*  ڲ
*  ˵    
*      
*      ڣ2019614
*      ߣм
******************************************************************************************************/
void t0_enable(void)
{
  T0M=0xC0;       //T0TR T0PS2 T0PS1 T0PS0 - - - -   000,Fcpu/256 001/128 010/64 011/32 100/16 101/8 110/4 111/2
  T0C=68;        //
  FT0IE=1;         //T0ж
  FGIE=1;
}
/******************************************************************************************************
*      ƣvoid t0_disable(void)
*      ܣt0ʱж
*  ڲ
*  ڲ
*  ˵    
*      
*      ڣ2019614
*      ߣм
******************************************************************************************************/
void t0_disable(void)
{
  T0M=0x00;	
  FT0IE=0;
}
/******************************************************************************************************
*      ƣvoid SysInit(void)
*      ܣϵͳʼ
*  ڲ
*  ڲ
*      ڣ2018.4.13
*      ߣ
******************************************************************************************************/
void SysInit(void)
{
  ADPCON=0x00;     
  ADR  =0x00;   //10λADC
  VREFH=0x00;   //ڲοѹ:  VDD:0x03   4.0V:0x02   3.0V:0x01    2.0V:0x00
  ADM  =0x00;   //P3.0 ΪAD

  T0M=0x00;	
  FT0IE=0; 
  TM1M =0x00;   
  TM2M =0x00;
  PWM1E=0x00;
  PWM2E=0x00;
  FGIE=0;
	
  //
  P1   =0xDF;
  P1M  =0xBF;      //0 =  ģʽ   1 =  ģʽ	
  P1W  =0x40;  
  P1UR =0x40;      //P_KEY_1  
  P1PD =0x00;
  
  P3   =0x00;       //
  P3M  =0xDC;       //
  P3W  =0x03;       //
  P3UR =0x03;       //0 =     1 =  	
  P3PD =0x00;       //0 =     1 =  

}
